package ZHash;

# Subserver website hashing
#
#
# Complex Hash
#
# Input, hostname to hash (e.g. www.mysite.com)
# Output, hashed hostname  (e.g. ??/??/www.mysite.com) where ?? are 
# selected from [A-Za-z0-9-_]
#

# Same as use Integer.pm, but without needing external package
BEGIN {
        if ( ! 1/2 ) {
           die "Test failed to detect initial floating point mode.\n".
               "Contact Zeus Support.\n";
        }
        $^H |= 1;
      }

# Check that arithmetic is in integers
if ( 1/2 ) {
  print 1/2;
  die "Setting integer mode failed. Contact Zeus support.\n";
}


# ----------------------------------------------------------
# Returns the simple hash of the website.

sub simple {

   my $site = shift;   
   $site = lc $site;
   
   my( $x, $y ) = ('a','a');

   $site =~ m/^(?:www\.)?([^\.]+)/; # match the first part excluding www.
   ( $x, $y ) = split( //, $1 ) if length $1 >= 2; # use first two chars

   return join( "/", $x, $y, $site );   

}

# ----------------------------------------------------------
# Returns the complex hash of the website.

sub complex {

    my $site = shift;
    my $h = 0;
    my $res = "";

    $site = lc $site;

    my @prefix = ( 'x','x','/','x','x','/' );
    my @conv   = (
		  'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L',
		  'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 
		  'Y', 'Z',
		  'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l',
		  'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x',
		  'y', 'z',
		  '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
		  '-', '_'
		  );

    my @chars = split //, $site;

    my $i;
    for( $i = 0; $i < $#chars + 1; $i++ ) {
	$h *= 129;
	$h += ord( $chars[$i] );
	$h += 987654321;
    }
    if( $h == 0 ) { $h = 1; }

    $prefix[0] = $conv[$h & 0x3f]; $h = $h >> 6;
    $prefix[1] = $conv[$h & 0x3f]; $h = $h >> 6;
    $prefix[3] = $conv[$h & 0x3f]; $h = $h >> 6;
    $prefix[4] = $conv[$h & 0x3f];

    return (join '', @prefix) . "$site";
}


1;
