# -*- perl -*-

package ZPDF;

sub readLinks
{

   my ( $pdfname ) = @_;
   my $pdflinkcachename = "$pdfname.linkcache";
   my ( $fm2nice, $nice2fm, $used_cache );

   $fm2nice = {};
   $nice2fm = {};

   $used_cache = 0;

   if ( -f $pdflinkcachename ) {
      # Wooh. We have a link cache file. Is it up-to-date?
      my ( $pdf_mtime, @ar );

      @ar = stat( $pdfname );
      if ( defined( @ar ) ) {
         $pdf_mtime = $ar[9];
         
         @ar = stat( $pdflinkcachename );
         if ( defined( @ar ) ) {
            if ( $ar[9] > $pdf_mtime ) {
               # The cache is more recent than the PDF. Use it.

               open( PDFCACHE, $pdflinkcachename );
               while ( <PDFCACHE> ) {
                  ( $k, $v ) = split /\s+/;
                  ${$fm2nice}{$k} = $v;
                  ${$nice2fm}{$v} = $k;
               }
               close( PDFCACHE );
               $used_cache = 1;
            }
         }
      }
   }

  if ( ! $used_cache ) {
     # Build a new cache from the PDF
     open( PDF, $pdfname );
     while ( <PDF> ) {
        # Note the use of nested parentheses matching on the next
        # line.
        # $1 becomes the whole newlink that matched
        # $2 is the nice text section of it
        # We then global match across the whole of this line and
        # dump the ($1,$2) pairs into @matches
        @matches = ( $_ =~ m@(M[^)\s]*newlink\.([^)\s]*))@gms );

        if ( defined( @matches ) ) {
          %hash = @matches; # Think about it.
          while ( ( $k, $v ) = each ( %hash ) ) {
            ${$fm2nice}{$k} = $v;
            ${$nice2fm}{$v} = $k;
          }
        }
     }
     close( PDF );

     # And build a cache please
     open( PDFOUT, ">$pdflinkcachename" );
     while ( ( $k, $v ) = each (%$fm2nice) ) {
        print PDFOUT "$k $v\n";
     }
     close( PDFOUT );
  }

  return ( $fm2nice, $nice2fm );
}

1;
